// -*- mode: C++; tab-width: 4; indent-tabs-mode: nil -*- (for GNU Emacs)
//
// Copyright (c) 1985-1998 Microsoft Corporation
//
// This file is part of the Microsoft Research IPv6 Network Protocol Stack.
// You should have received a copy of the Microsoft End-User License Agreement
// for this software along with this release; see the file "license.txt".
// If not, please see http://www.research.microsoft.com/msripv6/license.htm,
// or write to Microsoft Research, One Microsoft Way, Redmond, WA 98052-6399.
//
// Abstract:
//
// Network Address Protocol Translator (NAPT) definitions.
//


#ifndef NAPT_INCLUDED
#define NAPT_INCLUDED 1

#include <ip6.h>
// MEFBUG: get this from some header file
typedef struct in6_addr in6_addr;
typedef unsigned int in_addr;

// The napt device driver IOCTLs
#define IOCTL_NAPT_INIT               \
        CTL_CODE(FILE_DEVICE_NETWORK, \
                 0,                   \
                 METHOD_BUFFERED,     \
                 FILE_ANY_ACCESS)

typedef struct NaptIoctlInit {
  struct in6_addr rtAddr;
  unsigned char prefixLength;
} NaptIoctlInit;

// The napt device driver IOCTLs
#define IOCTL_NAPT_ADD_MAPPING   \
        CTL_CODE(FILE_DEVICE_DISK,    \
                 1,                   \
                 METHOD_BUFFERED,     \
                 FILE_ANY_ACCESS)

// The napt device driver IOCTLs
#define IOCTL_NAPT_DEL_MAPPING   \
        CTL_CODE(FILE_DEVICE_DISK,    \
                 2,                   \
                 METHOD_BUFFERED,     \
                 FILE_ANY_ACCESS)

// The napt device driver IOCTLs
#define IOCTL_NAPT_GET_IP6TOIP4_MAPPINGS \
        CTL_CODE(FILE_DEVICE_DISK,    \
                 3,                   \
                 METHOD_BUFFERED,     \
                 FILE_ANY_ACCESS)

#define IOCTL_NAPT_GET_IP4TOIP6_MAPPINGS \
        CTL_CODE(FILE_DEVICE_DISK,    \
                 4,                   \
                 METHOD_BUFFERED,     \
                 FILE_ANY_ACCESS)



typedef struct NaptIoctlMapping {
  in6_addr ip6addr;
  in_addr ip4addr;
} NaptIoctlMapping;

#endif  // NAPT_INCLUDED
